package inet.warehouse.model.persistance;

import inet.warehouse.model.AModel;
import inet.warehouse.model.Good;
import inet.warehouse.model.User;
import inet.warehouse.model.Warehouse;

public class RenewDb {
    public static void main(String[] args) {
        try {
            User admin = (User)saveIfNotExsists(new User("Administrator","Admin","Admin"));
            User boris = (User)saveIfNotExsists(new User("Boris","boris","boris"));
            User lucho = (User)saveIfNotExsists(new User("Лъчезар","lucho","lucho"));

            Warehouse centralStation = (Warehouse)saveIfNotExsists(new Warehouse("Admin's warehouse", "123 Industrial Str", admin));
            saveIfNotExsists(new Good("Cheese", "kg", new Float(.8), new Float(10.60), centralStation));
            saveIfNotExsists(new Good("Egg", "pcs", new Float(.7), new Float(10.00), centralStation));
            saveIfNotExsists(new Good("Milk","l",new Float(.03),new Float(10.00),centralStation));
            saveIfNotExsists(new Good("Beef","kg",new Float(1),new Float(100.34),centralStation));

            centralStation = (Warehouse)saveIfNotExsists(new Warehouse("Boris' warehouse", "1 Central Str", boris));
            saveIfNotExsists(new Good("Whiskey","l",new Float(.8),new Float(200),centralStation));
            saveIfNotExsists(new Good("Vodka","l",new Float(.7),new Float(200),centralStation));
            saveIfNotExsists(new Good("Tequilla","l",new Float(.03),new Float(200),centralStation));
            saveIfNotExsists(new Good("Rum","l",new Float(1),new Float(200),centralStation));

            centralStation = (Warehouse)saveIfNotExsists(new Warehouse("Lucho's warehouse","124 Street Str", lucho));
            saveIfNotExsists(new Good("Bagpack","pcs",new Float(.8),new Float(300), centralStation));
            saveIfNotExsists(new Good("Flashlight","pcs",new Float(345.7),new Float(300), centralStation));
            saveIfNotExsists(new Good("Boots","pcs",new Float(12.03),new Float(300), centralStation));
            saveIfNotExsists(new Good("Jacket","pcs",new Float(1),new Float(3000), centralStation));

//            saveIfNotExsists(new Language("bg_BG","/images/languages/bg.gif","Bulgarian"));
//            saveIfNotExsists(new Language("en_US","/images/languages/en_US.gif","English_American"));
//            saveIfNotExsists(new Language("ru_RU","/images/languages/ru_RU.gif","Russian"));

        } catch (PersistenceException e) {
            e.printStackTrace();
        }                        
    }

    private static AModel saveIfNotExsists(AModel aModel) throws PersistenceException {
        AModel[] models = aModel.filter();
        if(models.length == 0) {
            aModel.save();
            return aModel;
        } else {
            return models[0];
        }
    }   
}
