package inet.warehouse.util;

/**
 * Created by IntelliJ IDEA.
 * User: Luchesar
 * Date: May 2, 2004
 * Time: 10:01:17 AM
 * To change this template use Options | File Templates.
 */
public class Base64 {
    public static byte[] b = {'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',
                              'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
                              'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
                              'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',
                              'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
                              'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
                              'w', 'x', 'y', 'z', '0', '1', '2', '3',
                              '4', '5', '6', '7', '8', '9', '+', '/'};

    public static String encode(String s) {
        return encode (s.getBytes());
    }

    public static String encode(byte[] bytes) {
        int count = bytes.length / 3;
        int in = 0;
        int out = 0;
        int outLen = count * 4;
        if (bytes.length % 3 > 0)
            outLen += 4;
        byte[] outBytes = new byte[outLen];
        for (int i = 0; i < count; ++i) {
            outBytes[out++] = b[(bytes[in] & 0xFC) >> 2];
            outBytes[out++] = b[((bytes[in] & 0x03) << 4) | (bytes[in + 1] & 0xF0) >> 4];
            outBytes[out++] = b[((bytes[in + 1] & 0x0F) << 2) | (bytes[in + 2] & 0xC0) >> 6];
            outBytes[out++] = b[bytes[in + 2] & 0x3F];
            in += 3;
        }
        int remaining = bytes.length - count * 3;
        if (remaining == 2) {
            outBytes[out++] = b[(bytes[bytes.length - 2] & 0xFC) >> 2];
            outBytes[out++] = b[((bytes[bytes.length - 2] & 0x03) << 4) | (bytes[bytes.length - 1] & 0xF0) >> 4];
            outBytes[out++] = b[(bytes[bytes.length - 1] & 0x0F) << 2];
            outBytes[out++] = (byte)('=');
        }
        else if (remaining == 1) {
            outBytes[out++] = b[(bytes[bytes.length - 1] & 0xFC) >> 2];
            outBytes[out++] = b[(bytes[bytes.length - 1] & 0x03) << 4];
            outBytes[out++] = (byte) '=';
            outBytes[out++] = (byte) '=';
        }
        return new String(outBytes);
    }

    public static byte[] decode(String s) {
        int len = s.length();
        int count = len / 4;
        int outputLen = len * 3 / 4;
        if (s.charAt(len - 1) == '=') --outputLen;
        if (s.charAt(len - 2) == '=') --outputLen;
        byte[] bytes = new byte[outputLen];
        int in = 0;
        int ch1, ch2, ch3, ch4;
        for (int i = 0; i < count; ++i) {
            ch1 = c2i (s.charAt(i * 4));
            ch2 = c2i (s.charAt(i * 4 + 1));
            ch3 = c2i (s.charAt(i * 4 + 2));
            ch4 = c2i (s.charAt(i * 4 + 3));
            // abcd efgh ijkl mnop qrst uvwx
            // 00ab cdef 00gh ijkl 00mn opqr 00st uvwx
            bytes[in++] = (byte)((ch1 << 2) | (ch2 & 0x30) >> 4);
            if (ch3 == 64) break;
            bytes[in++] = (byte)((ch2 & 0x0F) << 4 | (ch3 & 0x3C) >> 2);
            if (ch4 == 64) break;
            bytes[in++] = (byte)(((ch3 & 0x03) << 6) | (ch4 & 0x3F));
        }
        return bytes;
    }

    public static int c2i(int ch) {
        if (ch >= 'A' && ch <= 'Z')
            ch -= 'A';
        else if (ch >= 'a' && ch <= 'z')
            ch = ch - 'a' + 26;
        else if (ch >= '0' && ch <= '9')
            ch = ch - '0' + 52;
        else if (ch == '+')
            ch = 62;
        else if (ch == '/')
            ch = 63;
        else if (ch == '=')
            ch = 64;
        return ch;
    }
}