
package inet.warehouse.web.actions;

import inet.warehouse.web.Action;
import inet.warehouse.web.ActionException;
import inet.warehouse.model.persistance.Id;
import inet.warehouse.model.persistance.ObjectNotFoundException;
import inet.warehouse.model.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Deletes a user with a given id and redirects to a list page
 */
public class DeleteUser extends Action {
    public static final String PAGE_OK = "/action/Users";

    public static final String REQ_DELETE_ID = "deleteId";

    public String execute(HttpServletRequest request, HttpServletResponse response) throws ActionException {
        Id id = new Id(request.getParameter(REQ_DELETE_ID));

        User m = new User();
        m.setId(id);
        try {
            m.delete();
        } catch (ObjectNotFoundException e) {
            addError(request, "errors.unableToDelete");
        }
        return PAGE_OK;
    }
}
