package inet.warehouse.web.tags;

import inet.warehouse.model.User;
import inet.warehouse.web.Constants;
import inet.warehouse.web.Action;

import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

public class IsLoggedTag extends TagSupport {
    /**
     * Checks to see if the user is logged in. Checks the session for a certain key
     * @return
     * @throws JspException
     */
    public int doStartTag() throws JspException {
        User user = (User) pageContext.getSession().getAttribute(Constants.AUTHENTICATED_USER_SESSION_KEY);

        if (user == null) {
            try {
                Action.addError((HttpServletRequest) pageContext.getRequest(), "errors.notLoggedIn");
                RequestDispatcher reqDisp = pageContext.getRequest().getRequestDispatcher("/");
                reqDisp.forward(pageContext.getRequest(),pageContext.getResponse());
                return SKIP_PAGE;
            } catch (Exception e) {
                throw new JspException(e);
            }
        } else {
            return EVAL_PAGE;
        }
    }
}
