<%@ taglib uri="http://java.sun.com/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jstl/fmt" prefix="fmt"%>
<%@ taglib uri="/WEB-INF/menu.tld" prefix="menu"%>
<%@ taglib uri="/WEB-INF/warehouse.tld" prefix="w"%>
<%@ taglib prefix="tags" tagdir="/WEB-INF/tags" %>

<%@ attribute name="textTitle"%>
<%@ attribute name="textHeader"%>
<%@ attribute name="textFooterMessage"%>
<%@ attribute name="align"%>
<%@ attribute name="valign"%>

<w:isLogged/>

<%-- One way of setting default values --%>
<c:if test="${empty align}">
    <c:set scope="page" var="align" value="left"/>
</c:if>

<c:if test="${empty valign}">
    <c:set scope="page" var="valign" value="top"/>
</c:if>

<html>
    <head>
        <title><c:out value="${textTitle}" default="Warehouse demo 1.0"/></title>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" type="text/css" href="<c:url value="/styles.css"/>"/>
    </head>
    <script language="javascript">
        <!--
        function showContextMenu(htmlContent) {
            var menuContainerVar = document.getElementById('contextMenuContainerId');
            if(htmlContent) {
               menuContainerVar.innerHTML = htmlContent;
            }
            menuContainerVar.style.visibility='visible';
        }

        function hideContextMenu() {
            var menuContainerVar = window.document.getElementById('contextMenuContainerId');
            menuContainerVar.style.visibility='hidden';
        }

        function fillManuContainer(htmlContent) {
            var menuContainerVar = document.getElementById('MenuContainerId');
            menuContainerVar.innerHTML = htmlContent;
        }
        //-->
    </script>

    <body leftmargin="0" topmargin="0">
        <table border="0" width="100%" height="100%" cellspacing="0" cellpadding="3">
            <tr height="50px">
                <td colspan="2">
                    <table cellpadding="0" cellspacing="0" border="0" width="100%" height="100%">
                        <tr>
                            <td width="1%"><img src="<c:url value="/logo.jpg"/>"/></td>
                            <td width="100%" class="textHeader"><c:out value="${textHeader}" default="Warehouse demo"/></td>
                        </tr>
                    </table>
				 </td>
            </tr>
            <tr>
                <td width="1%" valign="top">
                    <div id="MenuContainerId">
                        <menu:menu id="mainmenu" title="Menu" expandSelectedOnly="false" width="120px">
                            <menu:menuitem id="goods" text="Goods" url="~/action/GoodsList"/>
                            <menu:menuitem id="users" text="Users" url="~/action/Users"/>
                            <menu:menuitem id="exit" text="Exit" url="~/action/Logout"/>
                        </menu:menu>
                    </div>
                    <div id="contextMenuContainerId" style="visibility:hidden"></div>
                </td>
                <td align="<c:out value="${align}"/>" valign="<c:out value="${valign}"/>">
                    <jsp:doBody/>
                </td>
            </tr>
            <tr height="1%" class="textFooterMessage">
                <td colspan="2"><c:out value="${textFooterMessage}" default="copyright InetJava 2004"/></td>
            </tr>
        </table>
        <tags:changeLanguage position="absolute" top="20" left="60"/>
    </body>
</html>
