/**
 * Created by IntelliJ IDEA.
 * User: Luchesar
 * Date: May 2, 2004
 * Time: 9:19:34 PM
 * To change this template use Options | File Templates.
 */
package inet.warehouse.model.persistance.file;

import junit.framework.TestCase;
import inet.warehouse.model.persistance.User;
import inet.warehouse.model.AModel;
import inet.warehouse.model.persistance.WarehouseEntry;
import inet.warehouse.model.persistance.PersistenceException;

public class FilePersisterTest extends TestCase {
    public void testSave() throws Exception {
        FilePersister fp = FilePersister.getI();


        AModel[] all = fp.listAll(User.class);
        System.out.println("FilePersisterTest.testSave all.size->" + all.length);
        for (int i = 0; i < all.length; i++) {
            System.out.println("[" + i + "] ->" + all[i].getId());
        }

        User u = createUser(fp,"userName1","password1".toCharArray(),null);
        u.setParent(u);
        u.setEtries(new WarehouseEntry[]{new WarehouseEntry("etry1","value1"),new WarehouseEntry("etry2","value2"),});
        fp.save(u);
        User u2 = createUser(fp,"userName2","password2".toCharArray(),u);

        System.out.println("FilePersisterTest.testSave" + fp.listAll(u.getClass()));
        fp.saveInFile();
        fp.loadFromFile();

        AModel model = fp.load(u.getClass(), u.getId());
        assertNotNull(model);
        WarehouseEntry[] entrys = ((User)model).getEtries();

        for (int i = 0; i < entrys.length; i++) {
            System.out.println("FilePersisterTest.testSave entry name->"+entrys[i].getName());

        }
    }

    private User createUser(FilePersister fp,String name,char[] password,User parent) throws PersistenceException {
        User u = new User();
        u.setName(name);
        u.setPassword(password);
        u.setParent(parent);

        fp.save(u);
        return u;
    }

    public void t1estLoad() throws Exception {
        FilePersister fp = FilePersister.getI();
        User u = createUser(fp,"userName1","password1".toCharArray(),null);
        User u2 = createUser(fp,"userName2","password2".toCharArray(),u);

        u.setParent(u2);
        fp.save(u);
        fp.saveInFile();
        fp.loadFromFile();

        assertEquals(u,fp.load(User.class,u.getId()));
        assertEquals(u2,fp.load(User.class,u2.getId()));
        assertEquals(u.getParent(),u2);
    }

    public void t1estListAll() throws Exception {
        FilePersister fp = FilePersister.getI();
        AModel[] models = fp.listAll(User.class);
        for (int i = 0; i < models.length; i++) {
            assertEquals(models[i],fp.load(User.class,models[i].getId()));

        }
    }

}
